<template>
  <el-col :xs="24" :sm="24" :lg="8" style="margin-bottom: 1%">
    <el-card>
      <el-row style="margin-bottom: 5px">
        <el-button
          id="tour-apply-element"
          @click="apply"
          size="small"
          type="primary"
          style="width: 100%"
          plain
        >
          Применить
        </el-button>
      </el-row>
      <el-row>
        <el-button
          id="tour-delete-element"
          @click="deleteParams"
          size="small"
          type="danger"
          style="width: 100%"
          plain
          >Удалить
        </el-button>
      </el-row>
    </el-card>
  </el-col>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import { AxiosInstance } from "@/modules/AxiosInstance";
import ComponentMixin from "@/components/common/ComponentMixin";
import { MediaPlanParameters } from "@/interfaces/parameters/MediaPlanParameters";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";
import { MediaPlanParametersPlacementType } from "@/interfaces/parameters/MediaPlanParametersPlacementType";

/**
 * Компонент применения параметров автоматической расстановки медиаплана.
 */
@Component
export default class ApplyComponent extends Mixins(ComponentMixin) {
  // Параметры автоматической расстановки медиаплана
  private parameters: null | MediaPlanParameters = null;

  /**
   * Метод вызывается после создания компонента.
   */
  protected created(): void {
    // Подписываемся на событие получения параметров автоматической расстановки медиаплана
    this.subscribe(
      "media-plan-parameters-response",
      this.onMediaPlanParametersResponse
    );
  }

  /**
   * Метод вызывается после получения параметров автоматической расстановки медиаплана.
   * @param {MediaPlanParameters} parameters параметры автоматической расстановки медиаплана.
   */
  private onMediaPlanParametersResponse(parameters: MediaPlanParameters): void {
    this.parameters = parameters;
  }

  /**
   * Метод срабатывает после нажатия кнопки применения параметров.
   */
  private apply(): void {
    // Создаём копию параметров
    const copy = this.deepCopy(this.parameters) as MediaPlanParameters;

    // Если периоды указаны - фильтруем, отбрасывая пустые периоды
    if (copy.periods) {
      copy.periods = copy.periods.filter((x) => x.fromDate != null);
      // copy.periods.forEach(
      //   (period) =>
      //     (period.films = period.films.filter(
      //       (film) => film.inventoryPercent > 0.0
      //     ))
      // );
    }

    if (!this.checkParameter(copy)) return;

    copy.periods.forEach((period) => {
      // Переводим целочисленное число в процент
      period.percentPrime = period.percentPrime / 100;
      // Переводит строку в число
      period.inventory = Number(period.inventory);
      period.films.forEach(
        (film) => (film.inventoryPercent = film.inventoryPercent / 100)
      );
    });
    // Переводит строку в число
    copy.percentInventoryNeed = Number(copy.percentInventoryNeed);
    // Переводим целочисленное число в процент
    copy.percentInventoryNeed = copy.percentInventoryNeed / 100;

    this.saveOrUpdateParameters(copy);
  }

  private deleteParams(): void {
    this.notify("delete-media-plan-parameters");
    return;
  }

  /**
   * Метод глубокого копирования объекта.
   *
   * @param obj [unknown] объект, копию которого требуется получить.
   */
  private deepCopy(obj: unknown) {
    // Если объект не является объектом
    if (typeof obj !== "object") return obj;
    // Если объект пуст
    if (obj === null) return obj;
    // Если объект - дата
    if (Object.prototype.toString.call(obj) === "[object Date]") return obj;

    // Если объект - массив
    if (Array.isArray(obj)) {
      // Копия массива, которую будем наполнять
      const copy: unknown[] = [];

      // Итерируемся по текущему массиву
      for (let key in obj) {
        copy[key] = this.deepCopy(obj[key]);
      }

      // Возвращаем копию текущего массива
      return copy;
    }

    // Если объект - объект
    if (obj instanceof Object) {
      // Копия объекта, которую будем наполнять
      const copy: Record<string, unknown> = {};

      // Итерируемся по свойствам объекта, копию которого создаём
      for (let attribute in obj) {
        // Делаем проверку, что этот объект точно имеет свойство с таким названием
        if (Object.prototype.hasOwnProperty.call(obj, attribute)) {
          // Копируем свойство объекта в копию объекта
          copy[attribute] = this.deepCopy(
            (obj as Record<string, unknown>)[attribute]
          );
        }
      }

      // Возвращаем копию объекта
      return copy;
    }

    throw new Error("Неудалось инициализировать глубокое копирование.");
  }

  /**
   * Метод проверки параметров.
   */
  private checkParameter(parameters: MediaPlanParameters): boolean | undefined {
    if (!parameters?.periods || parameters.periods.length === 0) {
      this.notifyError("Не указаны периоды.");
      return;
    }
    if (!parameters?.times || parameters.times.length === 0) {
      this.notifyError("Не указаны временные интервалы.");
      return;
    }

    if (
      parameters.periods
        .map((period) => Number(period.inventory))
        .reduce((accumulator, value) => accumulator + value) === 0.0
    ) {
      this.notifyError("Не указан инвентарь.");
      return;
    }

    if (
      parameters.placement == MediaPlanParametersPlacementType.AFFINITIES &&
      parameters.audience == null
    ) {
      this.notifyError(
        "Не выбрана целевая аудитория при размещении по аффинити."
      );
      return;
    } else if (!parameters.placement) {
      this.notifyError("Не выбран алгоритм размещения.");
      return;
    }

    const isNotAllowedParameters = parameters.periods.some((period) => {
      const isPeriod = period.fromDate && period.beforeDate;
      const isInventory = period.inventory !== 0.0;
      const isFilms =
        period.films
          .map((film) => film.inventoryPercent)
          .reduce((accumulator, value) => accumulator + value, 0.0) !== 0.0;

      if (!isPeriod && !isInventory && !isFilms) return false;
      return !(isPeriod && isInventory && isFilms);
    });

    if (isNotAllowedParameters) {
      this.notifyError("Неверно указаны параметры.");
      return;
    }

    return true;
  }

  @AsyncRequestCatchException
  private async saveOrUpdateParameters(
    copy: MediaPlanParameters
  ): Promise<void> {
    const loading = this.$loading({
      lock: true,
      fullscreen: true,
    });
    try {
      await AxiosInstance.post("media-plan-parameters/set-parameters", copy);
      this.$notify({
        type: "success",
        title: "Параметры автоматического размещения",
        message: "Параметры успешно установлены",
      });
      setTimeout(() => {
        window.location.reload();
      }, 500);
    } finally {
      loading.close();
    }
  }

  private notifyError(message: string): void {
    this.$notify({
      type: "error",
      title: "Ошибка параметров",
      message: message,
    });
  }
}
</script>

<style lang="scss" scoped>
.el-card {
  height: 100%;
}
</style>
